设为首页收藏本站

中国膜结构网

 找回密码
 立即注册

QQ登录

只需一步,快速开始

膜结构车棚
膜结构车棚膜结构资质国产膜材 膜结构网中国膜结构协会
查看: 204|回复: 0

将块内的圆对象的坐标转换为该圆在当前dwg中的坐标并输出。相当于炸开块参照后再读...

[复制链接]
  • TA的每日心情
    开心
    2021-6-23 14:19
  • 签到天数: 1543 天

    [LV.Master]伴坛终老

    发表于 2021-1-1 15:26 | 显示全部楼层 |阅读模式
    1. static void MyGroupMyCommand ()
    2.         {
    3.                 //以下代码通过选择一个块参照,将块内的圆对象的坐标转换为该圆在当前dwg中的坐标并输出。相当于炸开块参照后再读取圆对象坐标的效果
    4.                 ads_name ObjName;
    5.                 ads_point pnt;
    6.                 AcDbObjectId objId;
    7.                 if (RTNORM != acedEntSel(_T(""),ObjName,pnt))
    8.                 {
    9.                         return;
    10.                 }

    11.                 acdbGetObjectId(objId,ObjName);
    12.                 AcDbEntity *pEnt=NULL;
    13.                 acdbOpenObject(pEnt,objId,AcDb::kForRead);
    14.                 if(pEnt->isKindOf(AcDbBlockReference::desc()))
    15.                 {
    16.                         AcDbBlockReference *pBlkRef=AcDbBlockReference::cast(pEnt);
    17.                         AcGeMatrix3d mat= pBlkRef->blockTransform();

    18.                         AcDbBlockTableRecordPointer BlkTBRec_Ptr(pBlkRef->blockTableRecord(),AcDb::kForRead);
    19.                         if(Acad::eOk  == BlkTBRec_Ptr.openStatus())
    20.                         {
    21.                                 AcDbBlockTableRecordIterator *pIt=NULL;
    22.                                 BlkTBRec_Ptr->newIterator(pIt);
    23.                                 for (pIt->start();!pIt->done();pIt->step())
    24.                                 {
    25.                                         AcDbEntity *pEntItem=NULL;
    26.                                         pIt->getEntity(pEntItem,AcDb::kForRead);
    27.                                         if(pEntItem->isKindOf(AcDbCircle::desc()))
    28.                                         {
    29.                                                 AcDbCircle *pCircle=AcDbCircle::cast(pEntItem);
    30.                                                 AcGePoint3d transPnt= mat * pCircle->center(); //将变换矩阵应用到对象的块内位置上,即得其在当前dwg图中的位置       
    31.                                                 acutPrintf(_T("块内位置:%f,%f\n"),pCircle->center().x,pCircle->center().y);
    32.                                                 acutPrintf(_T("在当前图中的位置%f,%f\n"),transPnt.x,transPnt.y);
    33.                                         }
    34.                                         pEntItem->close();
    35.                                 }
    36.                                 delete pIt;
    37.                         }
    38.                 }
    39.                 pEnt->close();
    40.         }
    复制代码
    回复


    http://www.mjgw.org/ 专业从事膜结构设计、制作加工、施工安装的膜结构工程服务,能够为客户提供专业的膜结构整体解决方案。做中国最好的膜结构综合服务平台。欢迎大家联系电话:198-7840-1958,QQ:463017170.
    相关关键词:膜结构车棚,膜结构车棚覆盖,膜结构车棚公司,膜结构车棚多少钱,膜结构车棚厂家,膜结构车棚价格,社区膜结构车棚,膜结构车棚膜布厂家 ,膜结构车棚哪家好,膜结构车棚多少钱一米,膜结构车棚报价,膜结构车棚哪里有,膜结构车棚定制,膜结构车棚安装,膜结构车棚设计,膜结构车棚电话,膜结构车棚加工,膜结构车棚膜布价格,膜结构车棚批发,膜结构车棚制造商,膜结构车棚生产厂家,膜结构车棚设计,膜结构车棚施工,膜结构车棚多少钱一平米,膜结构车棚订制,张拉膜车棚,张拉膜车棚覆盖,张拉膜车棚公司,张拉膜车棚多少钱,张拉膜车棚厂家,张拉膜车棚价格,社区张拉膜车棚,张拉膜车棚膜布厂家 ,张拉膜车棚哪家好,张拉膜车棚多少钱一米,张拉膜车棚报价,张拉膜车棚哪里有,张拉膜车棚定制,张拉膜车棚安装,张拉膜车棚设计,张拉膜车棚电话,张拉膜车棚加工,张拉膜车棚膜布价格,张拉膜车棚批发,张拉膜车棚制造商,张拉膜车棚生产厂家,张拉膜车棚设计,张拉膜车棚施工,张拉膜车棚多少钱一平米,张拉膜车棚订制,常用膜材品牌:德国杜肯、法国法拉利、德国海德斯、德国米乐、日本平岗、韩国秀博、比利时希运、美国赫虏伯、中国科宝、上海慧遥。

    使用道具 举报

    您需要登录后才可以回帖 登录 | 立即注册

    本版积分规则

    关闭

    推荐膜材品牌上一条 /6 下一条

    进口膜材 国产膜材 pvdf膜材ptfe膜材ETFE膜材
    最好的膜结构公司 一级膜结构资质 膜结构一级资质
    膜结构设计-膜结构十大品牌-etfe设计-充气膜结构
    诺科膜结构
    遨都膜结构设计
    中国膜结构网
    中国空间膜结构

    QQ|申请友链|手机版|中国膜结构论坛